// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_esr_msgs:msg/EsrTrack.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_ESR_MSGS__MSG__DETAIL__ESR_TRACK__STRUCT_HPP_
#define DELPHI_ESR_MSGS__MSG__DETAIL__ESR_TRACK__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_esr_msgs__msg__EsrTrack __attribute__((deprecated))
#else
# define DEPRECATED__delphi_esr_msgs__msg__EsrTrack __declspec(deprecated)
#endif

namespace delphi_esr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EsrTrack_
{
  using Type = EsrTrack_<ContainerAllocator>;

  explicit EsrTrack_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->canmsg = "";
      this->track_id = 0;
      this->track_lat_rate = 0.0f;
      this->track_group_changed = false;
      this->track_status = 0;
      this->track_angle = 0.0f;
      this->track_range = 0.0f;
      this->track_bridge_object = false;
      this->track_rolling_count = false;
      this->track_width = 0.0f;
      this->track_range_accel = 0.0f;
      this->track_med_range_mode = 0;
      this->track_range_rate = 0.0f;
    }
  }

  explicit EsrTrack_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    canmsg(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->canmsg = "";
      this->track_id = 0;
      this->track_lat_rate = 0.0f;
      this->track_group_changed = false;
      this->track_status = 0;
      this->track_angle = 0.0f;
      this->track_range = 0.0f;
      this->track_bridge_object = false;
      this->track_rolling_count = false;
      this->track_width = 0.0f;
      this->track_range_accel = 0.0f;
      this->track_med_range_mode = 0;
      this->track_range_rate = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _canmsg_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _canmsg_type canmsg;
  using _track_id_type =
    uint8_t;
  _track_id_type track_id;
  using _track_lat_rate_type =
    float;
  _track_lat_rate_type track_lat_rate;
  using _track_group_changed_type =
    bool;
  _track_group_changed_type track_group_changed;
  using _track_status_type =
    uint8_t;
  _track_status_type track_status;
  using _track_angle_type =
    float;
  _track_angle_type track_angle;
  using _track_range_type =
    float;
  _track_range_type track_range;
  using _track_bridge_object_type =
    bool;
  _track_bridge_object_type track_bridge_object;
  using _track_rolling_count_type =
    bool;
  _track_rolling_count_type track_rolling_count;
  using _track_width_type =
    float;
  _track_width_type track_width;
  using _track_range_accel_type =
    float;
  _track_range_accel_type track_range_accel;
  using _track_med_range_mode_type =
    uint8_t;
  _track_med_range_mode_type track_med_range_mode;
  using _track_range_rate_type =
    float;
  _track_range_rate_type track_range_rate;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__canmsg(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->canmsg = _arg;
    return *this;
  }
  Type & set__track_id(
    const uint8_t & _arg)
  {
    this->track_id = _arg;
    return *this;
  }
  Type & set__track_lat_rate(
    const float & _arg)
  {
    this->track_lat_rate = _arg;
    return *this;
  }
  Type & set__track_group_changed(
    const bool & _arg)
  {
    this->track_group_changed = _arg;
    return *this;
  }
  Type & set__track_status(
    const uint8_t & _arg)
  {
    this->track_status = _arg;
    return *this;
  }
  Type & set__track_angle(
    const float & _arg)
  {
    this->track_angle = _arg;
    return *this;
  }
  Type & set__track_range(
    const float & _arg)
  {
    this->track_range = _arg;
    return *this;
  }
  Type & set__track_bridge_object(
    const bool & _arg)
  {
    this->track_bridge_object = _arg;
    return *this;
  }
  Type & set__track_rolling_count(
    const bool & _arg)
  {
    this->track_rolling_count = _arg;
    return *this;
  }
  Type & set__track_width(
    const float & _arg)
  {
    this->track_width = _arg;
    return *this;
  }
  Type & set__track_range_accel(
    const float & _arg)
  {
    this->track_range_accel = _arg;
    return *this;
  }
  Type & set__track_med_range_mode(
    const uint8_t & _arg)
  {
    this->track_med_range_mode = _arg;
    return *this;
  }
  Type & set__track_range_rate(
    const float & _arg)
  {
    this->track_range_rate = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_esr_msgs__msg__EsrTrack
    std::shared_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_esr_msgs__msg__EsrTrack
    std::shared_ptr<delphi_esr_msgs::msg::EsrTrack_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EsrTrack_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->canmsg != other.canmsg) {
      return false;
    }
    if (this->track_id != other.track_id) {
      return false;
    }
    if (this->track_lat_rate != other.track_lat_rate) {
      return false;
    }
    if (this->track_group_changed != other.track_group_changed) {
      return false;
    }
    if (this->track_status != other.track_status) {
      return false;
    }
    if (this->track_angle != other.track_angle) {
      return false;
    }
    if (this->track_range != other.track_range) {
      return false;
    }
    if (this->track_bridge_object != other.track_bridge_object) {
      return false;
    }
    if (this->track_rolling_count != other.track_rolling_count) {
      return false;
    }
    if (this->track_width != other.track_width) {
      return false;
    }
    if (this->track_range_accel != other.track_range_accel) {
      return false;
    }
    if (this->track_med_range_mode != other.track_med_range_mode) {
      return false;
    }
    if (this->track_range_rate != other.track_range_rate) {
      return false;
    }
    return true;
  }
  bool operator!=(const EsrTrack_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EsrTrack_

// alias to use template instance with default allocator
using EsrTrack =
  delphi_esr_msgs::msg::EsrTrack_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_esr_msgs

#endif  // DELPHI_ESR_MSGS__MSG__DETAIL__ESR_TRACK__STRUCT_HPP_
