// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from delphi_esr_msgs:msg/EsrVehicle2.idl
// generated code does not contain a copyright notice
#include "delphi_esr_msgs/msg/detail/esr_vehicle2__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
delphi_esr_msgs__msg__EsrVehicle2__init(delphi_esr_msgs__msg__EsrVehicle2 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    delphi_esr_msgs__msg__EsrVehicle2__fini(msg);
    return false;
  }
  // scan_index_ack
  // use_angle_misalignment
  // clear_faults
  // high_yaw_angle
  // mr_only_transmit
  // lr_only_transmit
  // angle_misalignment
  // lateral_mounting_offset
  // radar_cmd_radiate
  // blockage_disable
  // maximum_tracks
  // turn_signal_status
  // vehicle_speed_valid
  // mmr_upside_down
  // grouping_mode
  // wiper_status
  // raw_data_enabled
  return true;
}

void
delphi_esr_msgs__msg__EsrVehicle2__fini(delphi_esr_msgs__msg__EsrVehicle2 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // scan_index_ack
  // use_angle_misalignment
  // clear_faults
  // high_yaw_angle
  // mr_only_transmit
  // lr_only_transmit
  // angle_misalignment
  // lateral_mounting_offset
  // radar_cmd_radiate
  // blockage_disable
  // maximum_tracks
  // turn_signal_status
  // vehicle_speed_valid
  // mmr_upside_down
  // grouping_mode
  // wiper_status
  // raw_data_enabled
}

delphi_esr_msgs__msg__EsrVehicle2 *
delphi_esr_msgs__msg__EsrVehicle2__create()
{
  delphi_esr_msgs__msg__EsrVehicle2 * msg = (delphi_esr_msgs__msg__EsrVehicle2 *)malloc(sizeof(delphi_esr_msgs__msg__EsrVehicle2));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(delphi_esr_msgs__msg__EsrVehicle2));
  bool success = delphi_esr_msgs__msg__EsrVehicle2__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
delphi_esr_msgs__msg__EsrVehicle2__destroy(delphi_esr_msgs__msg__EsrVehicle2 * msg)
{
  if (msg) {
    delphi_esr_msgs__msg__EsrVehicle2__fini(msg);
  }
  free(msg);
}


bool
delphi_esr_msgs__msg__EsrVehicle2__Sequence__init(delphi_esr_msgs__msg__EsrVehicle2__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  delphi_esr_msgs__msg__EsrVehicle2 * data = NULL;
  if (size) {
    data = (delphi_esr_msgs__msg__EsrVehicle2 *)calloc(size, sizeof(delphi_esr_msgs__msg__EsrVehicle2));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = delphi_esr_msgs__msg__EsrVehicle2__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        delphi_esr_msgs__msg__EsrVehicle2__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
delphi_esr_msgs__msg__EsrVehicle2__Sequence__fini(delphi_esr_msgs__msg__EsrVehicle2__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      delphi_esr_msgs__msg__EsrVehicle2__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

delphi_esr_msgs__msg__EsrVehicle2__Sequence *
delphi_esr_msgs__msg__EsrVehicle2__Sequence__create(size_t size)
{
  delphi_esr_msgs__msg__EsrVehicle2__Sequence * array = (delphi_esr_msgs__msg__EsrVehicle2__Sequence *)malloc(sizeof(delphi_esr_msgs__msg__EsrVehicle2__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = delphi_esr_msgs__msg__EsrVehicle2__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
delphi_esr_msgs__msg__EsrVehicle2__Sequence__destroy(delphi_esr_msgs__msg__EsrVehicle2__Sequence * array)
{
  if (array) {
    delphi_esr_msgs__msg__EsrVehicle2__Sequence__fini(array);
  }
  free(array);
}
