// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from delphi_esr_msgs:msg/EsrStatus1.idl
// generated code does not contain a copyright notice

#ifndef DELPHI_ESR_MSGS__MSG__DETAIL__ESR_STATUS1__STRUCT_HPP_
#define DELPHI_ESR_MSGS__MSG__DETAIL__ESR_STATUS1__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__delphi_esr_msgs__msg__EsrStatus1 __attribute__((deprecated))
#else
# define DEPRECATED__delphi_esr_msgs__msg__EsrStatus1 __declspec(deprecated)
#endif

namespace delphi_esr_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EsrStatus1_
{
  using Type = EsrStatus1_<ContainerAllocator>;

  explicit EsrStatus1_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->canmsg = "";
      this->time_stamp = 0;
      this->rolling_count = 0;
      this->comm_error = false;
      this->curvature = 0;
      this->scan_id = 0;
      this->yaw_rate = 0.0f;
      this->vehicle_speed_calc = 0.0f;
    }
  }

  explicit EsrStatus1_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    canmsg(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->canmsg = "";
      this->time_stamp = 0;
      this->rolling_count = 0;
      this->comm_error = false;
      this->curvature = 0;
      this->scan_id = 0;
      this->yaw_rate = 0.0f;
      this->vehicle_speed_calc = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _canmsg_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _canmsg_type canmsg;
  using _time_stamp_type =
    uint8_t;
  _time_stamp_type time_stamp;
  using _rolling_count_type =
    uint8_t;
  _rolling_count_type rolling_count;
  using _comm_error_type =
    bool;
  _comm_error_type comm_error;
  using _curvature_type =
    int16_t;
  _curvature_type curvature;
  using _scan_id_type =
    uint16_t;
  _scan_id_type scan_id;
  using _yaw_rate_type =
    float;
  _yaw_rate_type yaw_rate;
  using _vehicle_speed_calc_type =
    float;
  _vehicle_speed_calc_type vehicle_speed_calc;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__canmsg(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->canmsg = _arg;
    return *this;
  }
  Type & set__time_stamp(
    const uint8_t & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__rolling_count(
    const uint8_t & _arg)
  {
    this->rolling_count = _arg;
    return *this;
  }
  Type & set__comm_error(
    const bool & _arg)
  {
    this->comm_error = _arg;
    return *this;
  }
  Type & set__curvature(
    const int16_t & _arg)
  {
    this->curvature = _arg;
    return *this;
  }
  Type & set__scan_id(
    const uint16_t & _arg)
  {
    this->scan_id = _arg;
    return *this;
  }
  Type & set__yaw_rate(
    const float & _arg)
  {
    this->yaw_rate = _arg;
    return *this;
  }
  Type & set__vehicle_speed_calc(
    const float & _arg)
  {
    this->vehicle_speed_calc = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> *;
  using ConstRawPtr =
    const delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__delphi_esr_msgs__msg__EsrStatus1
    std::shared_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__delphi_esr_msgs__msg__EsrStatus1
    std::shared_ptr<delphi_esr_msgs::msg::EsrStatus1_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EsrStatus1_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->canmsg != other.canmsg) {
      return false;
    }
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->rolling_count != other.rolling_count) {
      return false;
    }
    if (this->comm_error != other.comm_error) {
      return false;
    }
    if (this->curvature != other.curvature) {
      return false;
    }
    if (this->scan_id != other.scan_id) {
      return false;
    }
    if (this->yaw_rate != other.yaw_rate) {
      return false;
    }
    if (this->vehicle_speed_calc != other.vehicle_speed_calc) {
      return false;
    }
    return true;
  }
  bool operator!=(const EsrStatus1_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EsrStatus1_

// alias to use template instance with default allocator
using EsrStatus1 =
  delphi_esr_msgs::msg::EsrStatus1_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace delphi_esr_msgs

#endif  // DELPHI_ESR_MSGS__MSG__DETAIL__ESR_STATUS1__STRUCT_HPP_
